#include "cubeplex.h"

int color = red;
int input1 = 1;
int input2 = 1;
int input3 = 1;
int brightness = 255;

void setup() {
  // initialize serial
  Serial.begin(115200);
  // how long each animation should run
  animationMax = 10;
  Serial.print("Animations run for "); Serial.print(animationMax); Serial.println(" seconds");
  // initialize the cube
  initCube();
}
void loop() {
  testallcolors();
  cube_rainbow_random();
  cube_rainbow_corner();
  planarSpin();
  fountain();
  trifade();
  shiftSquares();
  tunnel();
  chaseTheDot();
  planarFlop3D();
  Atom();
  Orbit();
  OrbitV2();
  planarSpin1();
  RaindropV2();
  randomCubedV2();
  RandomLines2();
  RandomPlanarFlop();
  Randomness();
  RandomnessV2();
  snake10v2();
}

void testallcolors() {
//Test Function
color=white;  // first color, after that it will be changed through all base colors
for (int i = 0; i < 8; i++) {
  for (int j = 0; j < 4; j++) {
    drawBox(color,brightness,0,0,j,3,3,j);
    flushBuffer();
    clearBuffer();
    delay(500);
    drawBox(off,brightness,0,0,0,3,3,3);
    flushBuffer();
    clearBuffer();
    //delay(250);
    }
  drawBox(color,brightness,0,0,0,3,3,3);
  flushBuffer();
  clearBuffer();
  delay(500);
  color = nextColor(color);
}
}

/*************************** RANDOM RAINBOW ***********************************\
| Random Color changes on all pixels                                           |
|                                                                              |
| Written By: Tauli, modified by James to fit this program                     |
\******************************************************************************/

void cube_rainbow_random() {
  
  byte spectrum2[24][3] = {
    {8,0,0},{7,1,0},{6,2,0},{5,3,0},{4,4,0},{3,5,0},{2,6,0},{1,7,0},
    {0,8,0},{0,7,1},{0,6,2},{0,5,3},{0,4,4},{0,3,5},{0,2,6},{0,1,7},
    {0,0,8},{1,0,7},{2,0,6},{3,0,5},{4,0,4},{5,0,3},{6,0,2},{7,0,1},
  };

  byte cube[4][4][4];
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed = 150;
  int x;
  int y;
  int z;
  //initCube();
  randomSeed(analogRead(0));
  for (byte x = 0; x <= 3; x++) {
    for (byte y = 0; y <= 3; y++) {
      for (byte z = 0; z <= 3; z++) {
        cube[x][y][z] = random(24);
      }
    }
  }
  while (continuePattern) {
  for (byte x = 0; x <= 3; x++) {
    for (byte y = 0; y <= 3; y++) {
      for (byte z = 0; z <= 3; z++) {
        byte val = cube[x][y][z];
        drawLed(red,  spectrum2[val][0],x,y,z);
        drawLed(green,spectrum2[val][1],x,y,z);
        drawLed(blue, spectrum2[val][2],x,y,z);
        if ((x+y+z) % 2 == 0) { cube[x][y][z] = (val+1) % 24;}
        else                  { cube[x][y][z] = val == 0 ? 23 : val-1;}
      }
    }
  }
  flushBuffer();
  clearBuffer();
  delay(animationSpeed);
  }
}

/**************************** RAINBOW CORNER EFFECT ***************************\
| Rainbow effect coming from a corner of the cube                              |
|                                                                              |
| Written By: Tauli, modified by James to fit this program                     |
\******************************************************************************/

byte spectrum[24][3] = {
  {8,0,0},{7,1,0},{6,2,0},{5,3,0},{4,4,0},{3,5,0},{2,6,0},{1,7,0},
  {0,8,0},{0,7,1},{0,6,2},{0,5,3},{0,4,4},{0,3,5},{0,2,6},{0,1,7},
  {0,0,8},{1,0,7},{2,0,6},{3,0,5},{4,0,4},{5,0,3},{6,0,2},{7,0,1},
};
byte offset    = 0;
byte shift[3]  = {0,0,0};
bool mirror[3] = {false,false,false};
byte anim[8]   = {0,2,0,1,0,2,0,1};

void drawCube_rainbow_corner() {
  int animationSpeed = 100;
  for (byte x = 0; x <= 3; x++) {
    for (byte y = 0; y <= 3; y++) {
      for (byte z = 0; z <= 3; z++) {
        byte xx = mirror[0] ? 3 - x : x;
        byte yy = mirror[1] ? 3 - y : y;
        byte zz = mirror[2] ? 3 - z : z;
        xx = shift[0] > xx ? 0 : xx - shift[0];
        yy = shift[1] > yy ? 0 : yy - shift[1];
        zz = shift[2] > zz ? 0 : zz - shift[2];
        byte val = (offset + xx + yy + zz) % 24;
        drawLed(red,  spectrum[val][0],x,y,z);
        drawLed(green,spectrum[val][1],x,y,z);
        drawLed(blue, spectrum[val][2],x,y,z);
      }
    }
  }
  flushBuffer();
  clearBuffer();
  offset = offset == 0 ? 23 : offset - 1;
  delay(animationSpeed);  
}

void moveAxis(byte axis) {
  for (int n = 1;n <= 3; n++) {
    shift[axis] = n;
    drawCube_rainbow_corner();
  }
  mirror[axis] = not mirror[axis];
  drawCube_rainbow_corner();
  for (int n = 2;n >= 0; n--) {
    shift[axis] = n;
    drawCube_rainbow_corner();
  }
}

void cube_rainbow_corner() {
  continuePattern = true;
  Serial.println("continuePattern set to true");
  byte n = 0;
  byte m = 0;
  while (continuePattern == true && n <= 7) {
      while (continuePattern == true && m < 50) {
        drawCube_rainbow_corner();
        m++;
      }
      moveAxis(anim[n]);
      n++;
  }
}

/********************************* PLANAR SPIN ********************************\
| A plane of light spins around the virtical center of the cube and changes    |
| colors after a certian number of rotations                                   |
|                                                                              |
| Written By: Asher Glick                                                      |
\******************************************************************************/
void planarSpin() {
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed = 50;
  int spinsPerColor = 5; // a spin is actually half a revolution
  while (continuePattern) {
    //if (continuePattern) {Serial.print(".");}
    int x = 0;
    int y = 0;
    for (int i = 0; i < spinsPerColor; i++) {
      for (int x = 0; x < 3; x++) {
        drawLine(color,x,0,0,3-x,3,0);
        drawLine(color,x,0,1,3-x,3,1);
        drawLine(color,x,0,2,3-x,3,2);
        drawLine(color,x,0,3,3-x,3,3);
        flushBuffer();
        clearBuffer();
        delay(animationSpeed);
      }
      for (int y = 0; y < 3; y++) {
        drawLine(color,3,y,0,0,3-y,0);
        drawLine(color,3,y,1,0,3-y,1);
        drawLine(color,3,y,2,0,3-y,2);
        drawLine(color,3,y,3,0,3-y,3);
        flushBuffer();
        clearBuffer();
        delay(animationSpeed);
      }
    }
    color = nextColor(color);
  }
}

/********************************** FOUNTAIN **********************************\
| Light shoots up the middle of the cube then once it reaches the top fall     |
| back down on the outside of the cube. After it hits the bottom it changes    |
| color and starts again                                                       |
|                                                                              |
| Written By: Asher Glick                                                      |
\******************************************************************************/
void fountain() {
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed = 100;
  while (continuePattern) {
    for (int z = 0; z <= 3; z++) {
      drawBoxWalls(color,1,1,z,2,2,z);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    for (int z = 3; z >= 0; z--) {
      drawBoxWalls(color,0,0,z,3,3,z);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    color=nextColor(color);
  }
}

/********************************** TRI-FADE **********************************\
| This animation fades through the red green and blue colors of the leds       |
| creating different mixtures of each of the colors.                           |
|                                                                              |
| Written By: Asher Glick                                                      |
\******************************************************************************/
void trifade() {
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed = 100;
  while (continuePattern) {
    // blue fade out, red fade in
    for (int i = 1; i <= 8; i++) {
      drawBox(blue,9-i,0,0,0,3,3,3);
      drawBox(red,i,0,0,0,3,3,3);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    // red fade out, green fade in
    for (int i = 1; i <= 8; i++) {
      drawBox(red,9-i,0,0,0,3,3,3);
      drawBox(green,i,0,0,0,3,3,3);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    // green fade out, blue fade in
    for (int i = 1; i <= 8; i++) {
      drawBox(green,9-i,0,0,0,3,3,3);
      drawBox(blue,i,0,0,0,3,3,3);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
  }
}

/******************************** SHIFT SQUARES *******************************\
| Three 2x2x2 squares start on the cube each a red green or blue. then they    |
| randomly move around the cube one at a time, if they crash into each other   |
| then then both leds turn on and while they occupy the same space they apear  |
| a different color                                                            |
|                                                                              |
| Written By: Asher Glick                                                      |
\******************************************************************************/
void shiftSquares() {
  int animationSpeed = 100;
  
  int blx = 2; // blue x
  int bly = 0; // blue y
  int blz = 0; // blue z
  
  int rdx = 0; // red x
  int rdy = 2; // red y
  int rdz = 0; // red z
  
  int gnx = 0; // green x
  int gny = 0; // green y
  int gnz = 2; // green z
  
  int * mover = &blx;
  continuePattern = true;
  Serial.println("continuePattern set to true");
  
  while(continuePattern) {
    switch (random(0,9)) {
      case 0: mover = &blx; break;
      case 1: mover = &bly; break;
      case 2: mover = &blz; break;
      case 3: mover = &rdx; break;
      case 4: mover = &rdy; break;
      case 5: mover = &rdz; break;
      case 6: mover = &gnx; break;
      case 7: mover = &gny; break;
      case 8: mover = &gnz; break;
    }
    *mover = (((*mover)+2)%4)-1;
    drawBox(blue ,abs(blx),abs(bly),abs(blz),abs(blx)+1,abs(bly)+1,abs(blz)+1);
    drawBox(red  ,abs(gnx),abs(gny),abs(gnz),abs(gnx)+1,abs(gny)+1,abs(gnz)+1);
    drawBox(green,abs(rdx),abs(rdy),abs(rdz),abs(rdx)+1,abs(rdy)+1,abs(rdz)+1);
    flushBuffer();
    clearBuffer();
    delay(animationSpeed);
    *mover = (((*mover)+2)%4)-1;
    drawBox(blue ,abs(blx),abs(bly),abs(blz),abs(blx)+1,abs(bly)+1,abs(blz)+1);
    drawBox(red  ,abs(gnx),abs(gny),abs(gnz),abs(gnx)+1,abs(gny)+1,abs(gnz)+1);
    drawBox(green,abs(rdx),abs(rdy),abs(rdz),abs(rdx)+1,abs(rdy)+1,abs(rdz)+1);
    flushBuffer();
    clearBuffer();
    delay(animationSpeed*2);
  }
}

/*********************************** TUNNEL ***********************************\
|
\******************************************************************************/
void tunnel() {
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed =100;
  
  int color1[]  = {R,R,R,R,B,B,B,B};
  int bright1[] = {2,4,6,8,2,4,6,8};
  int color2[]  = {B,B,B,B,R,R,R,R};
//int bright2[] = {6,4,2,0,6,4,2,0};
  int bright2[] = {8,6,4,2,8,6,4,2};
  
  int index[]   = {0,1,2,3,4,5,6,7};
  
  while (continuePattern) {
    drawBoxWalls(color1[index[0]],bright1[index[0]],1,1,0,2,2,0);
    drawBoxWalls(color2[index[0]],bright2[index[0]],1,1,0,2,2,0);
    drawBoxWalls(color1[index[1]],bright1[index[1]],1,1,1,2,2,1);
    drawBoxWalls(color2[index[1]],bright2[index[1]],1,1,1,2,2,1);
    drawBoxWalls(color1[index[2]],bright1[index[2]],1,1,2,2,2,2);
    drawBoxWalls(color2[index[2]],bright2[index[2]],1,1,2,2,2,2);
    drawBoxWalls(color1[index[3]],bright1[index[3]],1,1,3,2,2,3);
    drawBoxWalls(color2[index[3]],bright2[index[3]],1,1,3,2,2,3);
    
    drawBoxWalls(color1[index[4]],bright1[index[4]],0,0,3,3,3,3);
    drawBoxWalls(color2[index[4]],bright2[index[4]],0,0,3,3,3,3);
    drawBoxWalls(color1[index[5]],bright1[index[5]],0,0,2,3,3,2);
    drawBoxWalls(color2[index[5]],bright2[index[5]],0,0,2,3,3,2);
    drawBoxWalls(color1[index[6]],bright1[index[6]],0,0,1,3,3,1);
    drawBoxWalls(color2[index[6]],bright2[index[6]],0,0,1,3,3,1);
    drawBoxWalls(color1[index[7]],bright1[index[7]],0,0,0,3,3,0);
    drawBoxWalls(color2[index[7]],bright2[index[7]],0,0,0,3,3,0);
    
    
    flushBuffer();
    clearBuffer();
    for (int i = 0; i < 8; i++){
      //index[i] = index[i]==7?0:index[i]+1;
      index[i] = (index[i]+1)%8;
    }
    delay(animationSpeed);
    
  }
}
/******************************** CHASE THE DOT *******************************\
| A single point of light moves around the cube randomly and changes colors    |
| when it tries to go out of bounds                                            |
|                                                                              |
| Inspired By: Jonah Glick                                                     |
| Written By: Asher Glick                                                      |
\******************************************************************************/
void chaseTheDot() {
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed = 100;
  
  int xpos = 0;
  int ypos = 0;
  int zpos = 0;
  
  while (continuePattern) {
    switch(random(0,6)) {
      case 0:
        if (xpos > 0) {xpos--;break;}
        else color=nextColor(color);
      case 1:
        if (xpos < 3) {xpos++;break;}
        else color=nextColor(color);
        xpos--; break;
        
      case 2:
        if (ypos > 0) {ypos--;break;}
        else color=nextColor(color);
      case 3:
        if (ypos < 3) {ypos++;break;}
        else color=nextColor(color);
        ypos--; break;
      
      case 4:
        if (zpos > 0) {zpos--;break;}
        else color=nextColor(color);
      case 5:
        if (zpos < 3) {zpos++;break;}
        else color=nextColor(color);
        zpos--; break;
    }
    drawLed(color,xpos,ypos,zpos);
    flushBuffer();
    clearBuffer();
    delay(animationSpeed);
  }
}
/********************************* PLANAR FLOP ********************************\
| 
\******************************************************************************/
/******************************* PLANAR FLOP 3D *******************************\
| Version 2 of the planar flop, doing more complicated maths and 3D vectors    |
| 'n stuff. Making this function found the bug of reversed z axis line drawing |
\******************************************************************************/
void planarFlop3D() {
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed = 50;
  while (continuePattern) {
    
    for (int y = 3; y>0; y--){
      for (int z = 0; z < 4; z++) drawLine(color,0,3,z,3,y,z);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    for (int x = 3; x > 0; x--) {
      for (int z = 0; z < 4; z++) drawLine(color,0,3,z,x,0,z);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    
    
    for (int x = 0; x < 3; x++) {
      for (int y = 0; y < 4; y++) drawLine(color,0,y,0,x,y,3);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    for (int z = 3; z > 0; z--) {
      for (int y = 0; y < 4; y++) drawLine(color,0,y,0,3,y,z);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    
    for (int z = 0; z < 3; z++) {
      for (int x = 0; x < 4; x++) drawLine(color,x,0,0,x,3,z);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    for (int y = 3; y > 0; y--) {
      for (int x = 0; x < 4; x++) drawLine(color,x,0,0,x,y,3);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    
    for (int y = 0; y < 3; y++) {
      for (int z = 0; z < 4; z++) drawLine(color,3,0,z,0,y,z);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    for (int x = 0; x < 3; x++) {
      for (int z = 0; z < 4; z++) drawLine(color,3,0,z,x,3,z);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    
    for (int x = 3; x > 0; x--) {
      for (int y = 0; y < 4; y++) drawLine(color,3,y,3,x,y,0);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    for (int z = 0; z < 3; z++) {
      for (int y = 0; y < 4; y++) drawLine(color,3,y,3,0,y,z);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    
    for (int z = 3; z > 0; z--) {
      for (int x = 0; x < 4; x++) drawLine(color,x,3,3,x,0,z);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    } 
    for (int y = 0; y < 3; y++) {
      for (int x = 0; x < 4; x++) drawLine(color,x,3,3,x,y,0);
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    color = nextColor(color);
  }
}

/********************************* #11 Atom ***********************************\
| electrons orbit a neutron                                                    |
|                                                                              |
| Written By: Jules Meredith                                                   |
| (using Asher Glick's cubeplex.h/mappings.h/niceTimer.h)                      |
\******************************************************************************/
void Atom() {
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed = 50;
  int nxs=1; int nys=1; int nzs=2;
  int nxf=2; int nyf=2; int nzf=1;
  int b=0;
  int s=0;
  color=red;
  while (continuePattern) {
    for (int n = 0; n < 12; n++) {
      if (s==0 && b < 8) {
        b=b+1;
        drawBox(color,b,nxs,nys,nzs,nxf,nyf,nzf);
        flushBuffer();
        delay(animationSpeed);
        if (b==8) {
          s=1;
        }
      } 
      if (s==1 && b > 0) {
        b=b-1;
        drawBox(color,b,nxs,nys,nzs,nxf,nyf,nzf);
        flushBuffer();
        delay(animationSpeed);
        if (b==1) {
          s=0;
        }
      }
      clearBuffer();
      if (n==0) {
        drawLed(blue,1,0,0,1);
        drawLed(blue,8,0,1,1);
        drawLed(green,1,3,3,1);
        drawLed(green,8,3,2,1);
        flushBuffer();
      }
      if (n==1) {
        drawLed(blue,1,0,1,1);
        drawLed(blue,8,0,2,2);
        drawLed(green,1,3,2,1);
        drawLed(green,8,3,1,2);
        flushBuffer();
      }
      if (n==2) {
        drawLed(blue,1,0,2,2);
        drawLed(blue,8,0,3,2);
        drawLed(green,1,3,1,2);
        drawLed(green,8,3,0,2);
        flushBuffer();
      }
      if (n==3) {
        drawLed(blue,1,0,3,2);
        drawLed(blue,8,1,3,3);
        drawLed(green,1,3,0,2);
        drawLed(green,8,2,0,3);
        flushBuffer();
      }
      if (n==4) {
        drawLed(blue,1,1,3,3);
        drawLed(blue,8,2,3,3);
        drawLed(green,1,2,0,3);
        drawLed(green,8,1,0,3);
        flushBuffer();
      }
      if (n==5) {
        drawLed(blue,1,2,3,3);
        drawLed(blue,8,3,3,2);
        drawLed(green,1,1,0,3);
        drawLed(green,8,0,0,2);
        flushBuffer();
      }
      if (n==6) {
        drawLed(blue,1,3,3,2);
        drawLed(blue,8,3,2,2);
        drawLed(green,1,0,0,2);
        drawLed(green,8,0,1,2);
        flushBuffer();
      }
      if (n==7) {
        drawLed(blue,1,3,2,2);
        drawLed(blue,8,3,1,1);
        drawLed(green,1,0,1,2);
        drawLed(green,8,0,2,1);
        flushBuffer();
      }
      if (n==8) {
        drawLed(blue,1,3,1,1);
        drawLed(blue,8,3,0,1);
        drawLed(green,1,0,2,1);
        drawLed(green,8,0,3,1);
        flushBuffer();
      }
      if (n==9) {
        drawLed(blue,1,3,0,1);
        drawLed(blue,8,2,0,0);
        drawLed(green,1,0,3,1);
        drawLed(green,8,1,3,0);
        flushBuffer();
      }
      if (n==10) {
        drawLed(blue,1,2,0,0);
        drawLed(blue,8,1,0,0);
        drawLed(green,1,1,3,0);
        drawLed(green,8,2,3,0);
        flushBuffer();
      }
      if (n==11) {
        drawLed(blue,1,1,0,0);
        drawLed(blue,8,0,0,1);
        drawLed(green,1,2,3,0);
        drawLed(green,8,3,3,1);
        flushBuffer();
      }
      if (n==12) {
        drawLed(blue,1,0,0,1);
        drawLed(blue,8,0,1,1);
        drawLed(green,1,3,3,1);
        drawLed(green,8,2,3,1);
        flushBuffer();
      }
    }   
  }
}

/****************************** #2 orbit **************************************\
| A simple 4x4 block that orbits around the cube                               |
|                                                                              |
| Written By: Jules Meredith                                                   |
| (using Asher Glick's cubeplex.h/mappings.h/niceTimer.h)                      |
\******************************************************************************/
void Orbit() {
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed = 125;
  int a = 0;
  int b = 0;
    
      while (continuePattern) {
       for ( a = 0; a < 13; a++); {
        if (a = 1) {
          drawBoxWalls(color,8,1,0,0,1,0,3);
          drawBoxWalls(color-1,8,0,0,0,0,2,3);
          flushBuffer();
          clearBuffer();
          delay(animationSpeed);
        }
        if (a = 2) {
          drawBoxWalls(color,8,1,0,0,2,0,3);
          drawBoxWalls(color-1,8,0,0,0,0,1,3);
          flushBuffer();
          clearBuffer();
          delay(animationSpeed);
        }
        if (a = 3) {
          drawBoxWalls(color-1,8,0,0,0,0,0,3);
          drawBoxWalls(color,8,1,0,0,3,0,3);
          flushBuffer();
          clearBuffer();
          delay(animationSpeed);
        }
        if (a = 4) {
          drawBoxWalls(color,8,3,1,0,3,1,3);
          drawBoxWalls(color,8,1,0,0,3,0,3);
          flushBuffer();
          clearBuffer();
          delay(animationSpeed);
        }  
        if (a = 5) {
          drawBoxWalls(color,8,3,1,0,3,2,3);
          drawBoxWalls(color,8,2,0,0,3,0,3);
          flushBuffer();
          clearBuffer();
          delay(animationSpeed);
        }  
        if (a = 6) {
          drawBoxWalls(color,8,3,0,0,3,3,3);
          flushBuffer();
          clearBuffer();
          delay(animationSpeed);
        }  
        if (a = 7) {
          drawBoxWalls(color,8,2,3,0,2,3,3);
          drawBoxWalls(color,8,3,1,0,3,3,3);
          flushBuffer();
          clearBuffer();
          delay(animationSpeed);
        }  
        if (a = 8) {
          drawBoxWalls(color,8,2,3,0,1,3,3);
          drawBoxWalls(color,8,3,2,0,3,3,3);
          flushBuffer();
          clearBuffer();
          delay(animationSpeed);
        }  
        if (a = 9) {
          drawBoxWalls(color,8,3,3,0,0,3,3);
          flushBuffer();
          clearBuffer();
          delay(animationSpeed);
        }  
        if (a = 10) {
          drawBoxWalls(color,8,0,2,0,0,2,3);
          drawBoxWalls(color,8,2,3,0,0,3,3);
          flushBuffer();
          clearBuffer();
          delay(animationSpeed);
        }  
        if (a = 11) {
          drawBoxWalls(color,8,0,1,0,0,2,3);
          drawBoxWalls(color,8,1,3,0,1,3,3);
          flushBuffer();
          clearBuffer();
          delay(animationSpeed);
        }
        if (a = 12) {
          drawBoxWalls(color,8,0,0,0,0,3,3);
          flushBuffer();
          clearBuffer();
          delay(animationSpeed);
        }  
      }
   color = nextColor(color);
  }
}

/****************************** #12 orbitV2 ***********************************\
| A simple 4x4 side orbits around the cube                                     |
|                                                                              |
| Written By: Jules Meredith                                                   |
| (using Asher Glick's cubeplex.h/mappings.h/niceTimer.h)                      |
\******************************************************************************/
void OrbitV2() {
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed = 100;
  int a = 0;
  int b = 0;
  while (continuePattern) {
    for ( a = 0; a < 12; a++); {
      clearBuffer();
      if (a = 0) {
        drawBoxWalls(red,5,0,0,0,0,3,3);
        drawBoxWalls(blue,5,3,0,0,0,3,0);
        drawBoxWalls(green,5,0,3,0,3,3,3);
        flushBuffer();
        clearBuffer();
        delay(animationSpeed);
      }
      if (a = 1) {
        drawBoxWalls(red,5,1,0,0,1,0,3);
        drawBoxWalls(red,5,0,0,0,0,2,3);
        drawBoxWalls(blue,5,3,0,1,3,3,1);
        drawBoxWalls(blue,5,1,0,0,3,3,0);
        drawBoxWalls(green,5,0,2,0,3,2,0);
        drawBoxWalls(green,5,0,3,0,3,3,2);
        flushBuffer();
        clearBuffer();
        delay(animationSpeed);
      }
      if (a = 2) {
        drawBoxWalls(red,5,1,0,0,2,0,3);
        drawBoxWalls(red,5,0,0,0,0,1,3);
        drawBoxWalls(blue,5,3,0,2,3,3,1);
        drawBoxWalls(blue,5,2,0,0,3,3,0);
        drawBoxWalls(green,5,0,1,0,3,2,0);
        drawBoxWalls(green,5,0,3,0,3,3,1);
        flushBuffer();
        clearBuffer();          
        delay(animationSpeed);
      }
      if (a = 3) {
        drawBoxWalls(red,5,0,0,0,3,0,3);
        drawBoxWalls(blue,5,3,0,3,3,3,0);
        drawBoxWalls(green,5,0,0,0,3,3,0);
        flushBuffer();
        clearBuffer();
        delay(animationSpeed);
      }       
      if (a = 4) {
        drawBoxWalls(red,5,3,1,0,3,1,3);
        drawBoxWalls(red,5,1,0,0,3,0,3);
        drawBoxWalls(blue,5,2,0,3,2,3,3);
        drawBoxWalls(blue,5,3,0,3,3,3,1);
        drawBoxWalls(green,5,0,0,1,3,0,1);
        drawBoxWalls(green,5,0,0,0,3,2,0);
        flushBuffer();
        clearBuffer();
        delay(animationSpeed);
      }  
      if (a = 5) {
        drawBoxWalls(red,5,3,1,0,3,2,3);
        drawBoxWalls(red,5,2,0,0,3,0,3);
        drawBoxWalls(blue,5,1,0,3,2,3,3);
        drawBoxWalls(blue,5,3,0,3,3,3,2);
        drawBoxWalls(green,5,0,0,2,3,0,1);
        drawBoxWalls(green,5,0,0,0,3,1,0);
        flushBuffer();
        clearBuffer();
        delay(animationSpeed);
      }  
      if (a = 6) {
        drawBoxWalls(red,5,3,0,0,3,3,3);
        drawBoxWalls(blue,5,0,0,3,3,3,3);
        drawBoxWalls(green,5,0,0,3,3,0,0);
        flushBuffer();
        clearBuffer();
        delay(animationSpeed);
      }  
      if (a = 7) {
        drawBoxWalls(red,5,2,3,0,2,3,3);
        drawBoxWalls(red,5,3,1,0,3,3,3);
        drawBoxWalls(blue,5,0,0,2,0,3,2);
        drawBoxWalls(blue,5,0,0,3,2,3,3);
        drawBoxWalls(green,5,0,1,3,3,1,3);
        drawBoxWalls(green,5,0,0,3,3,0,1);
        flushBuffer();
        clearBuffer();
        delay(animationSpeed);
      }  
      if (a = 8) {
        drawBoxWalls(red,5,2,3,0,1,3,3);
        drawBoxWalls(red,5,3,2,0,3,3,3);
        drawBoxWalls(blue,5,0,0,1,0,3,2);
        drawBoxWalls(blue,5,0,0,3,1,3,3);
        drawBoxWalls(green,5,0,2,3,3,1,3);
        drawBoxWalls(green,5,0,0,3,3,0,2);
        flushBuffer();
        clearBuffer();
        delay(animationSpeed);
      }  
      if (a = 9) {
        drawBoxWalls(red,5,3,3,0,0,3,3);
        drawBoxWalls(blue,5,0,0,0,0,3,3);
        drawBoxWalls(green,5,0,3,3,3,0,3);
        flushBuffer();
        clearBuffer();
        delay(animationSpeed);
      }  
      if (a = 10) {
        drawBoxWalls(red,5,0,2,0,0,2,3);
        drawBoxWalls(red,5,2,3,0,0,3,3);
        drawBoxWalls(blue,5,1,0,0,1,3,0);
        drawBoxWalls(blue,5,0,0,2,0,3,0);
        drawBoxWalls(green,5,0,3,2,3,3,2);
        drawBoxWalls(green,5,0,3,3,3,1,3);
        flushBuffer();
        clearBuffer();
        delay(animationSpeed);
      }  
      if (a = 11) {
        drawBoxWalls(red,5,0,1,0,0,2,3);
        drawBoxWalls(red,5,1,3,0,1,3,3);
        drawBoxWalls(blue,5,2,0,0,1,3,0);
        drawBoxWalls(blue,5,0,0,1,0,3,0);
        drawBoxWalls(green,5,0,3,1,3,3,2);
        drawBoxWalls(green,5,0,3,3,3,2,3);
        flushBuffer();
        clearBuffer();
        delay(animationSpeed);
      }  
    }
  }
}

/****************************** #4 PlanarSpin1 ********************************\
| A simple variation on Asher Glicks's PlanarSpin                              |
|                                                                              |
| Written By: Jules Meredith                                                   |
| (using Asher Glick's cubeplex.h/mappings.h/niceTimer.h)                      |
\******************************************************************************/
void planarSpin1() {
  
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed =150;
  while (continuePattern) {
    int a = 1;
    int b = 0;
    int c = 3;
    int d = 2;
    int e = 3;
    int f = 3;
    int u = 3;
    int v = 1;
    int w = 0;
    int x = 0;
    int y = 2;
    int z = 0;
    for (int one = 1; one < 4; one ++){
      drawLine(color,a,b,c,d,e,f);
      drawLine(color,u,v,w,x,y,z);
      drawLine(color,a,b,c,u,v,w);
      drawLine(color,d,e,f,x,y,z);
      a=a+1;
      d=d-1;
      v=v+1;
      y=y-1;
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
    a = 3;
    b = 1;
    c = 3;
    d = 0;
    e = 2;
    f = 3;
    u = 2;
    v = 3;
    w = 0;
    x = 1;
    y = 0;
    z = 0;
    for (int two = 1; two < 4; two ++){
      drawLine(color,a,b,c,d,e,f);
      drawLine(color,u,v,w,x,y,z);
      drawLine(color,a,b,c,u,v,w);
      drawLine(color,d,e,f,x,y,z);
        b=b+1;
        e=e-1;
        u=u-1;
        x=x+1;
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);
    }
  color = nextColor(color);  
  }
}

/****************************** #13 RaindropV2 ********************************\
| random raindrops                                                             |
|                                                                              |
| Written By: Jules Meredith                                                   |
| (using Asher Glick's cubeplex.h/mappings.h/niceTimer.h)                      |
\******************************************************************************/
void RaindropV2() {
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed =150;
  int x=0;
  int y=0;
  int z=4;
  int a=1;
  while (continuePattern) {
    for (a = 100; a > 0; a--) {
      x=(random(0,4));
      y=(random(0,4));
      z=4;
      delay (250);
      for (int i = 4; i > 0; i--) {
        z = z - 1;
        drawLed(color,5,x,y,z);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      color = nextColor(color);
    }
  }
}

/****************************** #16 randomCubedV2 *****************************\
| as cubed but in a random sequence                                            |
|                                                                              |
| Written By: Jules Meredith                                                   |
| (using Asher Glick's cubeplex.h/mappings.h/niceTimer.h)                      |
\******************************************************************************/
void randomCubedV2() {
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed = 150;
  int w = -1;
  int x = 4;
  int y = 0;
  int z = 3;
  while (continuePattern) {
    w = -1;
    x = 4;
    switch(random(0,8)) {
      case 0:
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,0,0,3,x,x,w);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      color = nextColor(color);
      w = -1;
      x = 4;
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,0,0,3,w,w,x);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      break;
      case 1:
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,3,0,3,w,x,w);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      color = nextColor(color);
      w = -1;
      x = 4;
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,3,0,3,x,w,x);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      break;
      case 2:
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,3,3,3,w,w,w);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      color = nextColor(color);
      w = -1;
      x = 4;
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,3,3,3,x,x,x);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      break;
      case 3:
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,0,3,3,x,w,w);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      color = nextColor(color);
      w = -1;
      x = 4;
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,0,3,3,w,x,x);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      break;
      case 4:
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,0,0,0,x,x,x);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      color = nextColor(color);
      w = -1;
      x = 4;
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,0,0,0,w,w,w);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      break;
      case 5:
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,3,0,0,w,x,x);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      color = nextColor(color);
      w = -1;
      x = 4;
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,3,0,0,x,w,w);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      break;
      case 6:
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,3,3,0,w,w,x);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      color = nextColor(color);
      w = -1;
      x = 4;
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,3,3,0,x,x,w);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      break;
      case 7:
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,0,3,0,x,w,x);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      color = nextColor(color);
      w = -1;
      x = 4;
      for (int i = 4; i > 0; i--) {
        x = x - 1;
        w = w + 1;
        drawBox(color,4,0,3,0,w,x,w);
        flushBuffer(); 
        clearBuffer();
        delay(animationSpeed);
      }
      break;
      }
      clearBuffer();
   }  
}

/****************************** #7 RandomLines2 *******************************\
| total rewrite of #6 RandomLines (from 400 lines of code to just over 100)    |
|                                                                              |
| Written By: Jules Meredith                                                   |
| (using Asher Glick's cubeplex.h/mappings.h/niceTimer.h)                      |
\******************************************************************************/
void RandomLines2() {
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed =70;
  int x;
  int y;
  int z;
  while (continuePattern) {
    for (int tt = random(4,8); tt > 0; tt--) { 
      x = random(0,4);
      y = random(0,4);
      z = random(0,4);
      switch(random(0,6)) {
        case 0:
        z = 4;
        if (z = 4) {
          delay(300);
        }
        for (int i = 4; i > 0; i--) {
          z = z - 1;
          drawLed(color,5,x,y,z);
          flushBuffer();
          delay(animationSpeed);
        }
        break;
        case 1:
        z = -1;
        if (z = -1) {
          delay(300);
        }
        for (int i = 4; i > 0; i--) {
          z = z + 1;
          drawLed(color,5,x,y,z);
          flushBuffer();
          delay(animationSpeed);
        }
        break;
        case 2:
        y = 4;
        if (y = 4) {
          delay(300);
        }
        for (int i = 4; i > 0; i--) {
          y = y - 1;
          drawLed(color,5,x,y,z);
          flushBuffer();
          delay(animationSpeed);
        } 
        break;
        case 3:
        y = -1;
        if (y = -1) {
          delay(300);
        }
        for (int i = 4; i > 0; i--) {
          y = y + 1;
          drawLed(color,5,x,y,z);
          flushBuffer();
          delay(animationSpeed);
        } 
        break;    
        case 4:
        x = 4;
        if (x = 4) {
          delay(300);
        }
        for (int i = 4; i > 0; i--) {
          x = x - 1;
          drawLed(color,5,x,y,z);
          flushBuffer();
          delay(animationSpeed);
        }
        break;
        case 5:
        x = -1;
        if (x = -1) {
          delay(300);
        }
        for (int i = 4; i > 0; i--) {
          x = x + 1;
          drawLed(color,5,x,y,z);
          flushBuffer();
          delay(animationSpeed);
        }
        break;
      } 
      color = nextColor(color);
    }
    flushBuffer();
    clearBuffer();   
  }
}

/*************************** #3 RandomPlanarFlop ******************************\
| As Asher Glicks "Planar Flop 3D" but instead of following a set animated     |
| sequence this version is totally random.                                     |
|                                                                              |
| Written By: Jules Meredith                                                   |
| (using Asher Glick's cubeplex.h/mappings.h/niceTimer.h)                      |
\******************************************************************************/
void RandomPlanarFlop() {
  int side = 1;
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed = 50;
  while (continuePattern) {
    if (side == 1) {
      switch(random(0,5)) {
        case 0:
          for (int y = 3; y > -1; y--){
            for (int z = 0; z < 4; z++) drawLine(color,0,3,z,3,y,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          for (int x = 3; x > -1; x--) {
            for (int z = 0; z < 4; z++) drawLine(color,0,3,z,x,0,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 2;break;
        case 1:
          for (int y = 3; y > -1; y--) {
            for (int z = 0; z < 4; z++) drawLine(color,3,3,z,0,y,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          for (int x = 0; x < 4; x++) {
            for (int z = 0; z < 4; z++) drawLine(color,3,3,z,x,0,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 4;break;
        case 2:
          for (int y = 3; y > -1; y--) {
            for (int z = 0; z < 4; z++) drawLine(color,z,3,0,z,y,3);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }  
          for (int y = 3; y > -1; y--) {
            for (int x = 0; x < 4; x++) drawLine(color,x,3,0,x,0,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 6;break;
        case 3:
          for (int y = 3; y > -1; y--) {
            for (int z = 0; z < 4; z++) drawLine(color,z,3,3,z,y,0);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }  
          for (int y = 0; y < 4; y++) {
            for (int x = 0; x < 4; x++) drawLine(color,x,3,3,x,0,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 5;break;
        }
      }
    if (side == 2) {
      switch(random(5,10)) {
        case 5:
          for (int y = 0; y < 4; y++){
            for (int z = 3; z > -1; z--) drawLine(color,0,0,z,y,3,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          for (int x = 3; x > -1; x--) {
            for (int z = 3; z > -1; z--) drawLine(color,0,0,z,3,x,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 3;break;
        case 6:
          for (int y = 0; y < 4; y++) {
            for (int z = 0; z < 4; z++) drawLine(color,0,3,z,y,0,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          for (int x = 0; x < 4; x++) {
            for (int z = 0; z < 4; z++) drawLine(color,0,3,z,3,x,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 1; break;
        case 7:
          for (int y = 0; y < 4; y++) {
            for (int z = 0; z < 4; z++) drawLine(color,0,z,0,y,z,3);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }  
          for (int y = 3; y > -1; y--) {
            for (int x = 0; x < 4; x++) drawLine(color,0,x,0,3,x,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 6; break;
        case 8:
          for (int y = 0; y < 4; y++) {
            for (int z = 0; z < 4; z++) drawLine(color,0,z,3,y,z,0);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }  
          for (int y = 0; y < 4; y++) {
            for (int x = 0; x < 4; x++) drawLine(color,0,x,3,3,x,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 5; break;
        }
      }
    if (side == 3) {
      switch(random(10,15)) {
        case 10:
          for (int y = 0; y < 4; y++) {
            for (int z = 0; z < 4; z++) drawLine(color,0,0,z,3,y,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          for (int x = 3; x > -1; x--) {
            for (int z = 0; z < 4; z++) drawLine(color,0,0,z,x,3,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 2; break;
        case 11:
          for (int y = 0; y < 4; y++) {
            for (int z = 3; z > -1; z--) drawLine(color,3,0,z,0,y,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          for (int x = 0; x < 4; x++) {
            for (int z = 0; z < 4; z++) drawLine(color,3,0,z,x,3,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 4; break;
        case 12:
          for (int y = 0; y < 4; y++) {
            for (int z = 0; z < 4; z++) drawLine(color,z,0,3,z,y,0);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }  
          for (int y = 0; y < 4; y++) {
            for (int x = 0; x < 4; x++) drawLine(color,x,0,3,x,3,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 5; break;
        case 13:
          for (int y = 0; y < 4; y++) {
            for (int z = 0; z < 4; z++) drawLine(color,z,0,0,z,y,3);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }  
          for (int y = 3; y >0 -1; y--) {
            for (int x = 0; x < 4; x++) drawLine(color,x,0,0,x,3,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 6; break;
        }
      }
    if (side == 4) {
      switch(random(15,20)) {
        case 15:
          for (int y = 3; y > -1; y--){
            for (int z = 0; z < 4; z++) drawLine(color,3,3,z,y,0,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          for (int x = 0; x < 4; x++) {
            for (int z = 0; z < 4; z++) drawLine(color,3,3,z,0,x,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 1; break;
        case 16:
          for (int y = 3; y > -1; y--) {
            for (int z = 3; z > -1; z--) drawLine(color,3,0,z,y,3,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          for (int y = 3; y > -1; y--) {
            for (int z = 0; z < 4; z++) drawLine(color,3,0,z,0,y,z);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 3; break;
        case 17:
          for (int y = 3; y > -1; y--) {
            for (int z = 0; z < 4; z++) drawLine(color,3,z,3,y,z,0);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }  
          for (int y = 0; y < 4; y++) {
            for (int x = 0; x < 4; x++) drawLine(color,3,x,3,0,x,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 5; break;
        case 18:
          for (int y = 3; y > -1; y--) {
            for (int z = 0; z < 4; z++) drawLine(color,3,z,0,y,z,3);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }  
          for (int y = 3; y > -1; y--) {
            for (int x = 0; x < 4; x++) drawLine(color,3,x,0,0,x,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 6; break;
        }
      }
    if (side == 5) {
      switch(random(20,25)) {
        case 20:
          for (int y = 3; y > -1; y--){
            for (int z = 0; z < 4; z++) drawLine(color,z,3,3,z,0,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          for (int x = 0; x < 4; x++) {
            for (int z = 0; z < 4; z++) drawLine(color,z,3,3,z,x,0);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 1; break;
        case 21:
          for (int y = 3; y > -1; y--) {
            for (int z = 3; z > -1; z--) drawLine(color,0,z,3,3,z,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          for (int y = 3; y > -1; y--) {
            for (int z = 0; z < 4; z++) drawLine(color,0,z,3,y,z,0);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 2; break;
        case 22:
          for (int y = 3; y > -1; y--) {
            for (int z = 0; z < 4; z++) drawLine(color,z,0,3,z,3,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }  
          for (int y = 3; y > -1; y--) {
            for (int x = 0; x < 4; x++) drawLine(color,x,0,3,x,y,0);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 3; break;
        case 23:
          for (int y = 3; y > -1; y--) {
            for (int z = 0; z < 4; z++) drawLine(color,3,z,3,0,z,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }  
          for (int y = 0; y < 4; y++) {
            for (int x = 0; x < 4; x++) drawLine(color,3,x,3,y,x,0);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 4; break;
        }
      }
      if (side == 6) {
      switch(random(25,30)) {
        case 25:
          for (int y = 0; y < 4; y++) {
            for (int z = 0; z < 4; z++) drawLine(color,z,3,0,z,0,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          for (int x = 0; x < 4; x++) {
            for (int z = 0; z < 4; z++) drawLine(color,z,3,0,z,x,3);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 1; break;
        case 26:
          for (int y = 0; y < 4; y++) {
            for (int z = 3; z > -1; z--) drawLine(color,0,z,0,3,z,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          for (int y = 3; y > -1; y--) {
            for (int z = 0; z < 4; z++) drawLine(color,0,z,0,y,z,3);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 2; break;
        case 27:
          for (int y = 0; y < 4; y++) {
            for (int z = 0; z < 4; z++) drawLine(color,z,0,0,z,3,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }  
          for (int y = 3; y > -1; y--) {
            for (int x = 0; x < 4; x++) drawLine(color,x,0,0,x,y,3);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 3; break;
        case 28:
          for (int y = 0; y < 4; y++) {
            for (int z = 0; z < 4; z++) drawLine(color,3,z,0,0,z,y);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }  
          for (int y = 0; y < 4; y++) {
            for (int x = 0; x < 4; x++) drawLine(color,3,x,0,y,x,3);
            flushBuffer();
            clearBuffer();
            delay(animationSpeed);
          }
          side = 4; break;
        }
      }
    color = nextColor(color);
  }
}

/****************************** #8 Randomness *********************************\
| random sets of leds                                                          |
|                                                                              |
| Written By: Jules Meredith                                                   |
| (using Asher Glick's cubeplex.h/mappings.h/niceTimer.h)                      |
\******************************************************************************/
void Randomness() {
  
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed =70;
  int x;
  int y;
  int z;
    while (continuePattern) {
    for (int tt = random(4,8); tt > 0; tt--) { 
      x = random(0,4);
      y = random(0,4);
      z = random(0,4);
      drawLed(color,5,x,y,z);
      delay(animationSpeed);
    }  
    flushBuffer();
    clearBuffer();
    color = nextColor(color);
  }
}

/***************************** #10 RandomnessV2 *******************************\
| Random sets of leds                                                          |
|                                                                              |
| Written By: Jules Meredith                                                   |
| (using Asher Glick's cubeplex.h/mappings.h/niceTimer.h)                      |
\******************************************************************************/
void RandomnessV2() {
  continuePattern = true;
  Serial.println("continuePattern set to true");
  int animationSpeed = 400;
  int xpos[] = {0,0,0,0,0,0,0,0,0,0};
  int ypos[] = {0,0,0,0,0,0,0,0,0,0};
  int zpos[] = {0,0,0,0,0,0,0,0,0,0};
  int countx = 0;
  int county = 0;
  int led = 0;
  while (continuePattern) {
    for (int y = 0; y < 100; y++) {
      countx =10;
      county =9;
      for (int arr = 10; arr > 1; arr--){
        countx = countx - 1;
        county = county - 1;
        xpos[countx] = xpos[county];
        ypos[countx] = ypos[county];
        zpos[countx] = zpos[county];
        drawLed(color,xpos[countx],ypos[countx],zpos[countx]);
      }
      switch(random(0,6)) {
        case 0:
        if (xpos[0] > 0) {
          xpos[0]--; 
          break;
        }
        case 1:
        if (xpos[0] < 3) {
          xpos[0]++;
          break;
        }
        xpos[0]--; 
        break;
        case 2:
        if (ypos[0] > 0) {
          ypos[0]--;
          break;
        }
        case 3:
        if (ypos[0] < 3) {
          ypos[0]++;
          break;
        }
        ypos[0]--; break;
        case 4:
        if (zpos[0] > 0) {
          zpos[0]--;
          break;
        }
        case 5:
        if (zpos[0] < 3) {
          zpos[0]++;
          break;
        }
        zpos[0]--; 
        break;
      }
      flushBuffer();
    }
    clearBuffer();
    delay(animationSpeed);
    color=nextColor(color);
  }
}

/***************************** #1 Snake10v2 ***********************************\
| a 10 pixel snake writhing within the 4x4x4 cube - colour cycles in between   |
| all colours                                                                  |
|                                                                              |
| Written By: Jules Meredith                                                   |
| (using Asher Glick's cubeplex.h/mappings.h/niceTimer.h)                      |
\******************************************************************************/

void snake10v2() {
continuePattern = true;
Serial.println("continuePattern set to true");
int animationSpeed = 100;
int xpos[] = {0,0,0,0,0,0,0,0,0,0};
int ypos[] = {0,0,0,0,0,0,0,0,0,0};
int zpos[] = {0,0,0,0,0,0,0,0,0,0};
int countx = 0;
int county = 0;
int led = 0;
while (continuePattern) {
  for (int y = 0; y < 100; y++) {
    countx =10;
    county =9;
    for (int arr = 10; arr > 1; arr--){
      countx = countx - 1;
      county = county - 1;
      xpos[countx] = xpos[county];
      ypos[countx] = ypos[county];
      zpos[countx] = zpos[county];
      drawLed(color,xpos[countx],ypos[countx],zpos[countx]);
    }
    switch(random(0,6)) {
      case 0:
        if (xpos[0] > 0) {xpos[0]--;break;}
      case 1:
        if (xpos[0] < 3) {xpos[0]++;break;}
        xpos[0]--; break;
      case 2:
        if (ypos[0] > 0) {ypos[0]--;break;}
      case 3:
        if (ypos[0] < 3) {ypos[0]++;break;}
        ypos[0]--; break;
      case 4:
        if (zpos[0] > 0) {zpos[0]--;break;}
      case 5:
        if (zpos[0] < 3) {zpos[0]++;break;}
        zpos[0]--; break;
      }
      flushBuffer();
      clearBuffer();
      delay(animationSpeed);  
    }
    color=nextColor(color);
  }
}
